
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 Black
#property indicator_color6 Black
#property indicator_color7 Black
#property indicator_color8 Black

extern string  buffer.name             = "MACD Candle";
extern int     shift.sideways          =  0;
extern int     shift.up.down           =  0;

extern int   MACD_Fast = 2;
extern int   MACD_Slow = 6;
extern int MACD_Signal = 6;
extern color MACD_UP_ABOVE_ZERO_color = DeepSkyBlue;
extern color MACD_DN_ABOVE_ZERO_color = Silver;
extern color MACD_UP_BELOW_ZERO_color = Silver;
extern color MACD_DN_BELOW_ZERO_color = C'230,0,50';
extern bool Show_MTF_Text = true;
extern int Shift_MTF_Text_UP_DN = -6;
extern int Shift_MTF_Text_SIDEWAYS = 231;
extern string MTF_Text = "Courier New Bold";
extern int MTF_TextSIZE = 15;
extern bool Automatic_CandleSize = TRUE;
extern int Manual_CandleSize = 4;
int gi_136;
int gi_140;
extern int BARS = 1000;
double buffer_0[];
double buffer_1[];
double buffer_2[];
double buffer_3[];
double buffer_4[];
double buffer_5[];
double buffer_6[];
double buffer_7[];


int init() {
   IndicatorShortName("MACD Candles v4");
   IndicatorBuffers(8);
   SetIndexBuffer(0, buffer_0);
   SetIndexBuffer(1, buffer_1);
   SetIndexBuffer(2, buffer_2);
   SetIndexBuffer(3, buffer_3);
   SetIndexBuffer(4, buffer_4);
   SetIndexBuffer(5, buffer_5);
   SetIndexBuffer(6, buffer_6);
   SetIndexBuffer(7, buffer_7);
   
   if (Show_MTF_Text == TRUE) {
   int xpos=410,ypos=2;      
      Create_Object("AAB-Panel01", xpos-1,ypos+1, "gggg", 14, "Webdings", C'80,100,120');
   }
   return (0);
   }

int deinit() {
   deleteObjects();
   ObjectDelete("macdm1");
   ObjectDelete("macdm5");
   ObjectDelete("macdm15");
   ObjectDelete("macdm30");
   ObjectDelete("macdh1");
   ObjectDelete("macdh4");
   ObjectDelete("macdd1");
   ObjectDelete("macdw1");
   ObjectDelete("macdmn1");
   return (0);
   }

double f0_1(int a_shift_0 = 0) {
   return (iMACD(NULL, 0, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, a_shift_0));
   }

double f0_2(int a_shift_0 = 0) {
   return (iMACD(NULL, 0, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, a_shift_0));
   }

void f0_0(int ai_0, int ai_4) {
   double ld_24 = MathMax(Open[ai_4], Close[ai_4]);
   double ld_32 = MathMin(Open[ai_4], Close[ai_4]);
   double high_8 = High[ai_4];
   double low_16 = Low[ai_4];
   buffer_0[ai_4] = low_16;
   buffer_4[ai_4] = ld_32;
   buffer_1[ai_4] = low_16;
   buffer_5[ai_4] = ld_32;
   buffer_2[ai_4] = low_16;
   buffer_6[ai_4] = ld_32;
   buffer_3[ai_4] = low_16;
   buffer_7[ai_4] = ld_32;
   switch (ai_0) {
   case 1:
      buffer_0[ai_4] = high_8;
      buffer_4[ai_4] = ld_24;
      return;
   case 2:
      buffer_1[ai_4] = high_8;
      buffer_5[ai_4] = ld_24;
      return;
   case 3:
      buffer_2[ai_4] = high_8;
      buffer_6[ai_4] = ld_24;
      return;
   case 4:
      buffer_3[ai_4] = high_8;
      buffer_7[ai_4] = ld_24;
      return;
      return;
   }
   }

int start() {
   double ld_4;
   double ld_12;
   color color_20;
   color color_24;
   color color_28;
   color color_32;
   color color_36;
   color color_40;
   color color_44;
   color color_48;
   color color_52;
   gi_136 = 1;
   if (WindowBarsPerChart() < 400) gi_140 = 2;
   if (WindowBarsPerChart() < 200) gi_140 = 4;
   if (WindowBarsPerChart() < 120) gi_140 = 7;
   if (WindowBarsPerChart() <  50) gi_140 = 13;
   if (Automatic_CandleSize == FALSE) gi_140 = Manual_CandleSize;
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, gi_136, MACD_UP_ABOVE_ZERO_color);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, gi_136, MACD_UP_BELOW_ZERO_color);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, gi_136, MACD_DN_ABOVE_ZERO_color);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, gi_136, MACD_DN_BELOW_ZERO_color);
   SetIndexStyle(4, DRAW_HISTOGRAM, STYLE_SOLID, gi_140, MACD_UP_ABOVE_ZERO_color);
   SetIndexStyle(5, DRAW_HISTOGRAM, STYLE_SOLID, gi_140, MACD_UP_BELOW_ZERO_color);
   SetIndexStyle(6, DRAW_HISTOGRAM, STYLE_SOLID, gi_140, MACD_DN_ABOVE_ZERO_color);
   SetIndexStyle(7, DRAW_HISTOGRAM, STYLE_SOLID, gi_140, MACD_DN_BELOW_ZERO_color);
   for (int li_0 = MathMax(BARS - 1 - IndicatorCounted(), 1); li_0 >= 0; li_0--) {
      ld_4 = f0_1(li_0);
      ld_12 = f0_2(li_0);
      if (ld_4 > ld_12 && ld_4 > 0.0) f0_0(1, li_0);
      else {
         if (ld_4 > ld_12 && ld_4 < 0.0) f0_0(2, li_0);
         else {
            if (ld_4 < ld_12 && ld_4 > 0.0) f0_0(3, li_0);
            else
               if (ld_4 < ld_12 && ld_4 < 0.0) f0_0(4, li_0);
         }
      }
   }
   string ls_unused_56 = "";
   string ls_unused_64 = "";
   string ls_unused_72 = "";
   string ls_unused_80 = "";
   string ls_unused_88 = "";
   string ls_unused_96 = "";
   string ls_unused_104 = "";
   string ls_unused_112 = "";
   string ls_unused_120 = "";
   double imacd_128 = iMACD(NULL, PERIOD_M1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_136 = iMACD(NULL, PERIOD_M1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_144 = iMACD(NULL, PERIOD_M5, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_152 = iMACD(NULL, PERIOD_M5, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_160 = iMACD(NULL, PERIOD_M15, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_168 = iMACD(NULL, PERIOD_M15, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_176 = iMACD(NULL, PERIOD_M30, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_184 = iMACD(NULL, PERIOD_M30, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_192 = iMACD(NULL, PERIOD_H1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_200 = iMACD(NULL, PERIOD_H1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_208 = iMACD(NULL, PERIOD_H4, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_216 = iMACD(NULL, PERIOD_H4, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_224 = iMACD(NULL, PERIOD_D1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_232 = iMACD(NULL, PERIOD_D1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_240 = iMACD(NULL, PERIOD_W1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_248 = iMACD(NULL, PERIOD_W1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   double imacd_256 = iMACD(NULL, PERIOD_MN1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_MAIN, 0);
   double imacd_264 = iMACD(NULL, PERIOD_MN1, MACD_Fast, MACD_Slow, MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, 0);
   if (imacd_128 > imacd_136 && imacd_128 > 0.0) {
      ls_unused_56 = "-";
      color_20 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_128 < imacd_136 && imacd_128 < 0.0) {
      ls_unused_56 = "-";
      color_20 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_128 > imacd_136 && imacd_128 < 0.0) {
      ls_unused_56 = "-";
      color_20 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_128 < imacd_136 && imacd_128 > 0.0) {
      ls_unused_56 = "-";
      color_20 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_144 > imacd_152 && imacd_144 > 0.0) {
      ls_unused_64 = "-";
      color_24 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_144 < imacd_152 && imacd_144 < 0.0) {
      ls_unused_64 = "-";
      color_24 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_144 > imacd_152 && imacd_144 < 0.0) {
      ls_unused_64 = "-";
      color_24 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_144 < imacd_152 && imacd_144 > 0.0) {
      ls_unused_64 = "-";
      color_24 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_160 > imacd_168 && imacd_160 > 0.0) {
      ls_unused_72 = "-";
      color_28 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_160 < imacd_168 && imacd_160 < 0.0) {
      ls_unused_72 = "-";
      color_28 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_160 > imacd_168 && imacd_160 < 0.0) {
      ls_unused_72 = "-";
      color_28 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_160 < imacd_168 && imacd_160 > 0.0) {
      ls_unused_72 = "-";
      color_28 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_176 > imacd_184 && imacd_176 > 0.0) {
      ls_unused_80 = "-";
      color_32 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_176 < imacd_184 && imacd_176 < 0.0) {
      ls_unused_80 = "-";
      color_32 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_176 > imacd_184 && imacd_176 < 0.0) {
      ls_unused_80 = "-";
      color_32 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_176 < imacd_184 && imacd_176 > 0.0) {
      ls_unused_80 = "-";
      color_32 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_192 > imacd_200 && imacd_192 > 0.0) {
      ls_unused_88 = "-";
      color_36 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_192 < imacd_200 && imacd_192 < 0.0) {
      ls_unused_88 = "-";
      color_36 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_192 > imacd_200 && imacd_192 < 0.0) {
      ls_unused_88 = "-";
      color_36 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_192 < imacd_200 && imacd_192 > 0.0) {
      ls_unused_88 = "-";
      color_36 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_208 > imacd_216 && imacd_208 > 0.0) {
      ls_unused_96 = "-";
      color_40 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_208 <= imacd_216 && imacd_208 < 0.0) {
      ls_unused_96 = "-";
      color_40 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_208 > imacd_216 && imacd_208 < 0.0) {
      ls_unused_96 = "-";
      color_40 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_208 <= imacd_216 && imacd_208 > 0.0) {
      ls_unused_96 = "-";
      color_40 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_224 > imacd_232 && imacd_224 > 0.0) {
      ls_unused_104 = "-";
      color_44 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_224 < imacd_232 && imacd_224 < 0.0) {
      ls_unused_104 = "-";
      color_44 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_224 > imacd_232 && imacd_224 < 0.0) {
      ls_unused_104 = "-";
      color_44 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_224 < imacd_232 && imacd_224 > 0.0) {
      ls_unused_104 = "-";
      color_44 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_240 > imacd_248 && imacd_240 > 0.0) {
      ls_unused_112 = "-";
      color_48 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_240 < imacd_248 && imacd_240 < 0.0) {
      ls_unused_112 = "-";
      color_48 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_240 > imacd_248 && imacd_240 < 0.0) {
      ls_unused_112 = "-";
      color_48 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_240 < imacd_248 && imacd_240 > 0.0) {
      ls_unused_112 = "-";
      color_48 = MACD_DN_ABOVE_ZERO_color;
   }
   if (imacd_256 > imacd_136 && imacd_256 > 0.0) {
      ls_unused_120 = "-";
      color_52 = MACD_UP_ABOVE_ZERO_color;
   }
   if (imacd_256 < imacd_264 && imacd_256 < 0.0) {
      ls_unused_120 = "-";
      color_52 = MACD_DN_BELOW_ZERO_color;
   }
   if (imacd_256 > imacd_264 && imacd_256 < 0.0) {
      ls_unused_120 = "-";
      color_52 = MACD_UP_BELOW_ZERO_color;
   }
   if (imacd_256 < imacd_136 && imacd_256 > 0.0) {
      ls_unused_120 = "-";
      color_52 = MACD_DN_ABOVE_ZERO_color;
   }
   if (Show_MTF_Text == TRUE) {
      
      ObjectDelete("macdh1");
      ObjectCreate("macdh1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("macdh1", "H1", MTF_TextSIZE, MTF_Text, color_36);
      ObjectSet("macdh1", OBJPROP_CORNER, 0);
      ObjectSet("macdh1", OBJPROP_XDISTANCE, (Shift_MTF_Text_SIDEWAYS + 20) * MTF_TextSIZE / 9);
      ObjectSet("macdh1", OBJPROP_YDISTANCE, Shift_MTF_Text_UP_DN + 10);
      ObjectDelete("macdh4");
      ObjectCreate("macdh4", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("macdh4", "H4", MTF_TextSIZE, MTF_Text, color_40);
      ObjectSet("macdh4", OBJPROP_CORNER, 0);
      ObjectSet("macdh4", OBJPROP_XDISTANCE, (Shift_MTF_Text_SIDEWAYS + 40) * MTF_TextSIZE / 9);
      ObjectSet("macdh4", OBJPROP_YDISTANCE, Shift_MTF_Text_UP_DN + 10);
   }
   return (0);
   }

   int Create_Object( string K, int x, int y,  string Text, int FontSize, string Font, color Color ) 
   {
   K=buffer.name+K;
   ObjectCreate( K, OBJ_LABEL, 0, 0, 0 );
   ObjectSet( K, OBJPROP_CORNER, 0);
   ObjectSet( K, OBJPROP_XDISTANCE,x+shift.sideways);
   ObjectSet( K, OBJPROP_YDISTANCE,y+shift.up.down);
   ObjectSetText(K, Text, FontSize, Font, Color);
   }

void deleteObjects()
   {
   ObjectDelete(buffer.name+"AAB-Panel01");
   GetLastError();
   }     